/* TroiaPreview
 * version 1.0 date 2005-03-24
 * Copyright (C) 2003-2005 Stefan Schuermans <1stein@schuermans.info>
 * Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
 */

#ifndef INC_Pixel
#define INC_Pixel

//a 3D pixel
typedef struct _tPixel3D
{
  unsigned char Wall; //1..4 for walls, 5 for ceiling, 6 for floor
  unsigned short X, Y;
} tPixel3D;

//convert 3D pixel structure to text
//pTxt must point to at least 16 bytes
void Pixel3D2Txt( tPixel3D Pixel, char * pTxt );

//convert text to 3D pixel structure
tPixel3D Txt2Pixel3D( char * pTxt );

//get a random pixel
tPixel3D PixelRandom( );

//convert direction to text
//direction is encoded as the number on the numpad (e.g. 8 for up)
//pTxt must point to at least 16 bytes
void Dir2Txt( unsigned char Dir, char * pTxt );

//convert text to direction
//direction is encoded as the number on the numpad (e.g. 8 for up)
unsigned char Txt2Dir( char * pTxt );

//get a random direction
unsigned char DirRandom( );

//rotate a direction
//direction is encoded as the number on the numpad (e.g. 8 for up)
//angle +1 rotates 45 degrees clockwise
unsigned char DirRotate( unsigned char Dir, int Angle );

//move from one pixel to a neighbour pixel
//direction is encoded as the number on the numpad (e.g. 8 for up)
//the new direction (to follow a straight line) is also returned
void Pixel3DMove( tPixel3D Src, unsigned char Dir, tPixel3D * pDest, unsigned char * pNewDir );

#endif //#ifndef INC_Pixel

