/* TroiaPreview
 * version 1.0 date 2005-03-24
 * Copyright (C) 2003-2005 Stefan Schuermans <1stein@schuermans.info>
 * Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
 */

#ifndef INC_Ticker
#define INC_Ticker

#include "Pixel.h"

//constants
#define TickerCnt 16
#define TickerMinWidth 20
#define TickerMaxWidth 512
#define TickerMinSpeed 1.0
#define TickerMaxSpeed 100.0

//initialize tickers
void TickerInit( );

//check if ticker is active
int TickerGetActive( unsigned int TickerNo );

//enable / disable ticker
void TickerSetActive( unsigned int TickerNo, int Active );

//get ticker text length
unsigned int TickerGetTextLen( unsigned int TickerNo );

//set ticker text
void TickerSetText( unsigned int TickerNo, char * pTxt );

//get ticker position, direction and width
void TickerGetPos( unsigned int TickerNo, tPixel3D * pPix, unsigned char * pDir, unsigned int * pWidth );

//set ticker position, direction and width
void TickerSetPos( unsigned int TickerNo, tPixel3D Pix, unsigned char Dir, unsigned int Width );

//get ticker color
void TickerGetColor( unsigned int TickerNo, unsigned short * pForeColor, unsigned short * pBackColor );

//set ticker color
void TickerSetColor( unsigned int TickerNo, unsigned short ForeColor, unsigned short BackColor );

//get ticker reference time
double TickerGetRefTime( unsigned int TickerNo );

//set ticker reference time
void TickerSetRefTime( unsigned int TickerNo, double RefTime );

//get ticker speed
double TickerGetSpeed( unsigned int TickerNo );

//set ticker speed
void TickerSetSpeed( unsigned int TickerNo, double Speed );

//called periodically to do some work
void TickerTask( );

#endif //#ifndef INC_Ticker

