/* TroiaPreview
 * version 1.0 date 2005-03-24
 * Copyright (C) 2003-2005 Stefan Schuermans <1stein@schuermans.info>
 * Copyleft: GNU public license - http://www.gnu.org/copyleft/gpl.html
 */

#include <string.h>
#include <windows.h>

#include "Tools.h"

//global variables for time
unsigned long TimeRefTicks = 0;
double TimeOffset = 0.0;

//stristr
char * stristr( char * Str, char * Search )
{
  long I, L;
  L = strlen( Search );
  for( I = 0; Str[I] != 0; I++ )
    if( strnicmp( Str + I, Search, L ) == 0 )
      return Str + I;
  return NULL;
}

//absolute value
double Abs( double X )
{
  if( X < 0.0 )
    return -X;
  return X;
}

//sign of value
double Sign( double X )
{
  if( X > 0.0 )
    return 1.0;
  if( X < 0.0 )
    return -1.0;
  return 0.0;
}

//some kind of modulo for a double
double DoubleModulo( double Value, double Modul )
{
  if( Value < 0.0 )
  {
    Value /= Modul;
    Value -= (double)(int)Value;
    return Modul + Value * Modul;
  }
  else
  {
    Value /= Modul;
    Value -= (double)(int)Value;
    return Value * Modul;
  }
}

//check range of a char
char CharMinMax( char Value, char Min, char Max )
{
  if( Value < Min ) Value = Min;
  if( Value > Max ) Value = Max;
  return Value;
}

//check range of a short
short ShortMinMax( short Value, short Min, short Max )
{
  if( Value < Min ) Value = Min;
  if( Value > Max ) Value = Max;
  return Value;
}

//check range of a long
long LongMinMax( long Value, long Min, long Max )
{
  if( Value < Min ) Value = Min;
  if( Value > Max ) Value = Max;
  return Value;
}

//check range of a float
float FloatMinMax( float Value, float Min, float Max )
{
  if( Value < Min ) Value = Min;
  if( Value > Max ) Value = Max;
  return Value;
}

//check range of a double
double DoubleMinMax( double Value, double Min, double Max )
{
  if( Value < Min ) Value = Min;
  if( Value > Max ) Value = Max;
  return Value;
}

//set time
void TimeSet( double Time )
{
  TimeRefTicks = GetTickCount( );
  TimeOffset = Time;
}

//get time
double TimeGet( )
{
  unsigned long Ticks;
  long Tick;
  Ticks = GetTickCount( );
  Tick = Ticks - TimeRefTicks;
  return (double)Tick / 1000.0 + TimeOffset;
}
